//+------------------------------------------------------------------+
//|                                               BandsHistogram.mq4 |
//|                                                 |
//|                                                   AlexeiBv@ya.ru |
//+------------------------------------------------------------------+
#property copyright " "
#property link      "AlexeiBv@ya.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Red

extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double BandsDeviations=2.0;
extern int PRICE=1;

/*
PRICE    :
PRICE_CLOSE 0   
PRICE_OPEN 1   
PRICE_HIGH 2   
PRICE_LOW 3   
PRICE_MEDIAN 4  , (high+low)/2 
PRICE_TYPICAL 5  , (high+low+close)/3 
PRICE_WEIGHTED 6   , (high+low+close+close)/4 
*/

double Buffer[];
double Buffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  string short_name;
  //---- 1 additional buffer used for counting.
  // IndicatorBuffers(2);
   IndicatorDigits(Digits);
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Buffer);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer1);
 //  SetIndexBuffer(1,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="BBandsWidthHisto ("+BandsPeriod+","+BandsShift+","+DoubleToStr(BandsDeviations,3)+") points: ";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  //----
   int i,k,counted_bars=IndicatorCounted();
   double buff,buff1;
//----
   if(Bars<=BandsPeriod) return(0);
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=limit-1; i>=0; i--)
   {
      buff=(iBands(NULL,0,BandsPeriod,BandsDeviations,BandsShift,PRICE,1,i)-iBands(NULL,0,BandsPeriod,BandsDeviations,BandsShift,PRICE,2,i))/Point;
      buff1=(iBands(NULL,0,BandsPeriod,BandsDeviations,BandsShift,PRICE,1,i+1)-iBands(NULL,0,BandsPeriod,BandsDeviations,BandsShift,PRICE,2,i+1))/Point;
      if(buff1<buff) Buffer[i]=buff;
      else Buffer1[i]=buff;
   }    
//----
   return(0);
  }
//+------------------------------------------------------------------+